<template>
    <div>
      <b-jumbotron style="background:transparent !important">
        <b-container fluid="lg">
        <b-card
          img-top
          tag="article"
          style="max-width: 20rem;"
          class="mb-2"
        >
          <b-card-text >
          Click here to start
          </b-card-text>
          <b-button id="startRoundBTN" v-on:click="startGenerate">
          New Round
          </b-button>
        </b-card>
      </b-container>
      </b-jumbotron>
      <b-container fluid="sm"  v-if="addCard_startGame_seen">
        <div>
          <b-button id="addCardBtn" size="lg" v-on:click="addcard_seen = !addcard_seen">Add card(s)</b-button>
          <p>You can add a maximum of 5 cards</p>
        </div>
        <b-form class="add-card-div" v-if="addcard_seen">
            <b-form-input v-model="cardText" placeholder="Enter card content"></b-form-input>
            <b-button style="background:#E8A87C"  variant="outline-secondary" :disabled="isDisabled" v-on:click="addQuestion">Add Me :)</b-button>
            <p>You have added {{ clickCounter }} cards</p>
        </b-form>
        <b-jumbotron style="background:transparent!important" lead="Ready!">
          <b-card
            img-top
            tag="article"
            style="max-width: 20rem;"
            class="mb-2"
            v-on:click="GoToGamePage"
          >
            <b-card-text>
            Let's Go!
            </b-card-text>
            </b-card>
        </b-jumbotron>
      </b-container>
    </div>
</template>

<script>

import { Api } from '@/Api'

export default {

  name: 'Prepare',
  methods: {

    addQuestion(e, variant = null) {
      e.preventDefault()
      if (this.cardText === '') {
        variant = 'danger'
        this.$bvToast.toast('card must have a content', {
          title: `Notification ${variant || 'default'}`,
          variant: variant,
          solid: true
        })
        return
      }
      this.clickCounter += 1
      this.disableAddCard()
      const newCard = {
        content: this.cardText,
        categories: this.category
      }
      Api.post('/cards', newCard)
        .then(response => {
          this.addedCardID = response.data._id
          this.deleteCardinRound()
          if (this.allCards.indexOf(this.addedCardID) === -1) {
            this.allCards.push(this.addedCardID)
          }
        })
        .catch(error => {
          console.log(error)
          this.rounds = []
        })
    },

    deleteCardinRound() {
      this.removedCard = this.allCards.shift()

      Api.delete(`/rounds/${this.roundID}/cards/${this.removedCard._id}`)
        .then(response => {
          this.backendRemovedCard = response.data
          const roundCards = {
            cards: [this.addedCardID]
          }
          this.addCardinRound(this.roundID, roundCards)
          if (this.allCards.indexOf(this.addedCardID) === -1) {
            this.allCards.push(this.addedCardID)
          }
        })
        .catch(error => {
          console.log(error)
          this.rounds = []
        })
    },

    addCardinRound(roundId, newCards) {
      Api.patch(`/rounds/${roundId}`, newCards)
        .then(response => {
          this.rounds = response.data
        })
        .catch(error => {
          console.log(error)
          this.rounds = []
        })
    },

    generateRound() {
      const currentGame = this.$store.state.newGame
      const filter = currentGame.categories
      Api.post(`/rounds/cards/category/${filter}`)
        .then(response => {
          this.roundID = response.data._id
          this.allCards = response.data.cards
          if (this.$store.state.newGame != null) {
            const newRounds = {
              rounds: [response.data._id]
            }

            const gameId = this.$store.state.newGame._id

            Api.patch(`/games/${gameId}`, newRounds)
              .then(response => {
                this.updatedGame = response.data
              })
              .catch(error => {
                console.log(error)
                this.rounds = []
              })
          }
        })
        .catch(error => {
          console.log(error)
          this.rounds = []
        })
    },

    GoToGamePage() {
      this.$router.push('game')
    },

    disableAddCard() {
      if (this.clickCounter === 5) {
        this.isDisabled = true
      }
    },

    startGenerate() {
      this.generateRound()
      this.addCard_startGame_seen = true
    }
  },
  data() {
    return {
      addCard_startGame_seen: false,
      addcard_seen: false,
      isDisabled: false,
      clickCounter: 0,
      cardText: '',
      rounds: [],
      allCards: [],
      roundID: '',
      addedCardID: '',
      removedCard: '',
      category: '',
      backendRemovedCard: '',
      updatedGame: ''
    }
  }
}
</script>

<style scoped>
#addCardBtn{
  border: none;
  margin: 20px;
  background: #30867b;
}
.add-card-div {
  margin: 20px;
}
#startRoundBTN{
  background: #E8A87C;
  border: none;
}
#startRoundBTN:hover {
  color: white;
  box-shadow: 0 12px 16px 0 rgba(0,0,0,0.24), 0 17px 50px 0 rgba(0,0,0,0.19);
}
</style>
